#ifdef TIFF_TAG_LOOKUP
#undef TIFF_TAG
#define TIFF_TAG(NAME, ID, VALUE) [VALUE] = NAME,
#else
#undef TIFF_TAG
#define TIFF_TAG(NAME, ID, VALUE) ID = VALUE,
#endif /* ifdef TIFF_TAG_LOOKUP */

TIFF_TAG("NEW_SUBFILE_TYPE"              , TIFF_PUBLIC_TAG_NEW_SUBFILE_TYPE                 , 0x00fe)
TIFF_TAG("SUBFILE_TYPE"                  , TIFF_PUBLIC_TAG_SUBFILE_TYPE                     , 0x00ff)
TIFF_TAG("IMAGE_WIDTH"                   , TIFF_PUBLIC_TAG_IMAGE_WIDTH                      , 0x0100)
TIFF_TAG("IMAGE_LENGTH"                  , TIFF_PUBLIC_TAG_IMAGE_LENGTH                     , 0x0101)
TIFF_TAG("BITS_PER_SAMPLE"               , TIFF_PUBLIC_TAG_BITS_PER_SAMPLE                  , 0x0102)
TIFF_TAG("COMPRESSION"                   , TIFF_PUBLIC_TAG_COMPRESSION                      , 0x0103)
TIFF_TAG("PHOTOMETRIC_INTERPRETATION"    , TIFF_PUBLIC_TAG_PHOTOMETRIC_INTERPRETATION       , 0x0106)
TIFF_TAG("THRESHHOLDING"                 , TIFF_PUBLIC_TAG_THRESHHOLDING                    , 0x0107)
TIFF_TAG("CELL_WIDTH"                    , TIFF_PUBLIC_TAG_CELL_WIDTH                       , 0x0108)
TIFF_TAG("CELL_LENGTH"                   , TIFF_PUBLIC_TAG_CELL_LENGTH                      , 0x0109)
TIFF_TAG("FILL_ORDER"                    , TIFF_PUBLIC_TAG_FILL_ORDER                       , 0x010a)
TIFF_TAG("DOCUMENT_NAME"                 , TIFF_PUBLIC_TAG_DOCUMENT_NAME                    , 0x010d)
TIFF_TAG("IMAGE_DESCRIPTION"             , TIFF_PUBLIC_TAG_IMAGE_DESCRIPTION                , 0x010e)
TIFF_TAG("MAKE"                          , TIFF_PUBLIC_TAG_MAKE                             , 0x010f)
TIFF_TAG("MODEL"                         , TIFF_PUBLIC_TAG_MODEL                            , 0x0110)
TIFF_TAG("STRIP_OFFSETS"                 , TIFF_PUBLIC_TAG_STRIP_OFFSETS                    , 0x0111)
TIFF_TAG("ORIENTATION"                   , TIFF_PUBLIC_TAG_ORIENTATION                      , 0x0112)
TIFF_TAG("SAMPLES_PER_PIXEL"             , TIFF_PUBLIC_TAG_SAMPLES_PER_PIXEL                , 0x0115)
TIFF_TAG("ROWS_PER_STRIP"                , TIFF_PUBLIC_TAG_ROWS_PER_STRIP                   , 0x0116)
TIFF_TAG("STRIP_BYTE_COUNTS"             , TIFF_PUBLIC_TAG_STRIP_BYTE_COUNTS                , 0x0117)
TIFF_TAG("MIN_SAMPLE_VALUE"              , TIFF_PUBLIC_TAG_MIN_SAMPLE_VALUE                 , 0x0118)
TIFF_TAG("MAX_SAMPLE_VALUE"              , TIFF_PUBLIC_TAG_MAX_SAMPLE_VALUE                 , 0x0119)
TIFF_TAG("X_RESOLUTION"                  , TIFF_PUBLIC_TAG_X_RESOLUTION                     , 0x011a)
TIFF_TAG("Y_RESOLUTION"                  , TIFF_PUBLIC_TAG_Y_RESOLUTION                     , 0x011b)
TIFF_TAG("PLANAR_CONFIGURATION"          , TIFF_PUBLIC_TAG_PLANAR_CONFIGURATION             , 0x011c)
TIFF_TAG("PAGE_NAME"                     , TIFF_PUBLIC_TAG_PAGE_NAME                        , 0x011d)
TIFF_TAG("X_POSITION"                    , TIFF_PUBLIC_TAG_X_POSITION                       , 0x011e)
TIFF_TAG("Y_POSITION"                    , TIFF_PUBLIC_TAG_Y_POSITION                       , 0x011f)
TIFF_TAG("FREE_OFFSETS"                  , TIFF_PUBLIC_TAG_FREE_OFFSETS                     , 0x0120)
TIFF_TAG("FREE_BYTE_COUNTS"              , TIFF_PUBLIC_TAG_FREE_BYTE_COUNTS                 , 0x0121)
TIFF_TAG("GRAY_RESPONSE_UNIT"            , TIFF_PUBLIC_TAG_GRAY_RESPONSE_UNIT               , 0x0122)
TIFF_TAG("GRAY_RESPONSE_CURVE"           , TIFF_PUBLIC_TAG_GRAY_RESPONSE_CURVE              , 0x0123)
TIFF_TAG("T4_OPTIONS"                    , TIFF_PUBLIC_TAG_T4_OPTIONS                       , 0x0124)
TIFF_TAG("T6_OPTIONS"                    , TIFF_PUBLIC_TAG_T6_OPTIONS                       , 0x0125)
TIFF_TAG("RESOLUTION_UNIT"               , TIFF_PUBLIC_TAG_RESOLUTION_UNIT                  , 0x0128)
TIFF_TAG("PAGE_NUMBER"                   , TIFF_PUBLIC_TAG_PAGE_NUMBER                      , 0x0129)
TIFF_TAG("TRANSFER_FUNCTION"             , TIFF_PUBLIC_TAG_TRANSFER_FUNCTION                , 0x012d)
TIFF_TAG("SOFTWARE"                      , TIFF_PUBLIC_TAG_SOFTWARE                         , 0x0131)
TIFF_TAG("DATE_TIME"                     , TIFF_PUBLIC_TAG_DATE_TIME                        , 0x0132)
TIFF_TAG("ARTIST"                        , TIFF_PUBLIC_TAG_ARTIST                           , 0x013b)
TIFF_TAG("HOST_COMPUTER"                 , TIFF_PUBLIC_TAG_HOST_COMPUTER                    , 0x013c)
TIFF_TAG("PREDICTOR"                     , TIFF_PUBLIC_TAG_PREDICTOR                        , 0x013d)
TIFF_TAG("WHITE_POINT"                   , TIFF_PUBLIC_TAG_WHITE_POINT                      , 0x013e)
TIFF_TAG("PRIMARY_CHROMATICITIES"        , TIFF_PUBLIC_TAG_PRIMARY_CHROMATICITIES           , 0x013f)
TIFF_TAG("COLOR_MAP"                     , TIFF_PUBLIC_TAG_COLOR_MAP                        , 0x0140)
TIFF_TAG("HALFTONE_HINTS"                , TIFF_PUBLIC_TAG_HALFTONE_HINTS                   , 0x0141)
TIFF_TAG("TILE_WIDTH"                    , TIFF_PUBLIC_TAG_TILE_WIDTH                       , 0x0142)
TIFF_TAG("TILE_LENGTH"                   , TIFF_PUBLIC_TAG_TILE_LENGTH                      , 0x0143)
TIFF_TAG("TILE_OFFSETS"                  , TIFF_PUBLIC_TAG_TILE_OFFSETS                     , 0x0144)
TIFF_TAG("TILE_BYTE_COUNTS"              , TIFF_PUBLIC_TAG_TILE_BYTE_COUNTS                 , 0x0145)
TIFF_TAG("INK_SET"                       , TIFF_PUBLIC_TAG_INK_SET                          , 0x014c)
TIFF_TAG("INK_NAMES"                     , TIFF_PUBLIC_TAG_INK_NAMES                        , 0x014d)
TIFF_TAG("NUMBER_OF_INKS"                , TIFF_PUBLIC_TAG_NUMBER_OF_INKS                   , 0x014e)
TIFF_TAG("DOT_RANGE"                     , TIFF_PUBLIC_TAG_DOT_RANGE                        , 0x0150)
TIFF_TAG("TARGET_PRINTER"                , TIFF_PUBLIC_TAG_TARGET_PRINTER                   , 0x0151)
TIFF_TAG("EXTRA_SAMPLES"                 , TIFF_PUBLIC_TAG_EXTRA_SAMPLES                    , 0x0152)
TIFF_TAG("SAMPLE_FORMAT"                 , TIFF_PUBLIC_TAG_SAMPLE_FORMAT                    , 0x0153)
TIFF_TAG("S_MIN_SAMPLE_VALUE"            , TIFF_PUBLIC_TAG_S_MIN_SAMPLE_VALUE               , 0x0154)
TIFF_TAG("S_MAX_SAMPLE_VALUE"            , TIFF_PUBLIC_TAG_S_MAX_SAMPLE_VALUE               , 0x0155)
TIFF_TAG("TRANSFER_RANGE"                , TIFF_PUBLIC_TAG_TRANSFER_RANGE                   , 0x0156)
TIFF_TAG("JPEG_PROC"                     , TIFF_PUBLIC_TAG_JPEG_PROC                        , 0x0200)
TIFF_TAG("JPEG_INTERCHANGE_FORMAT"       , TIFF_PUBLIC_TAG_JPEG_INTERCHANGE_FORMAT          , 0x0201)
TIFF_TAG("JPEG_INTERCHANGE_FORMAT_LENGTH", TIFF_PUBLIC_TAG_JPEG_INTERCHANGE_FORMAT_LENGTH   , 0x0202)
TIFF_TAG("JPEG_RESTART_INTERVAL"         , TIFF_PUBLIC_TAG_JPEG_RESTART_INTERVAL            , 0x0203)
TIFF_TAG("JPEG_LOSSLESS_PREDICTORS"      , TIFF_PUBLIC_TAG_JPEG_LOSSLESS_PREDICTORS         , 0x0205)
TIFF_TAG("JPEG_POINT_TRANSFORMS"         , TIFF_PUBLIC_TAG_JPEG_POINT_TRANSFORMS            , 0x0206)
TIFF_TAG("JPEG_QTABLES"                  , TIFF_PUBLIC_TAG_JPEG_QTABLES                     , 0x0207)
TIFF_TAG("JPEG_DCTABLES"                 , TIFF_PUBLIC_TAG_JPEG_DCTABLES                    , 0x0208)
TIFF_TAG("JPEG_ACTABLES"                 , TIFF_PUBLIC_TAG_JPEG_ACTABLES                    , 0x0209)
TIFF_TAG("YCBCR_COEFFICIENTS"            , TIFF_PUBLIC_TAG_YCBCR_COEFFICIENTS               , 0x0211)
TIFF_TAG("YCBCR_SUB_SAMPLING"            , TIFF_PUBLIC_TAG_YCBCR_SUB_SAMPLING               , 0x0212)
TIFF_TAG("YCBCR_POSITIONING"             , TIFF_PUBLIC_TAG_YCBCR_POSITIONING                , 0x0213)
TIFF_TAG("REFERENCE_BLACK_WHITE"         , TIFF_PUBLIC_TAG_REFERENCE_BLACK_WHITE            , 0x0214)
TIFF_TAG("COPYRIGHT"                     , TIFF_PUBLIC_TAG_COPYRIGHT                        , 0x8298)
